#include "stdafx.h"
#include "MFC_progDoc.h"
#include "MFC_progView.h"
#include "DrawDoc.h"
#include "DrawView.h"
#include "TextView.h"
#include "ChildFrm.h"

#include <math.h>

typedef struct tagTHREADPARMS {
	BOOL* pContFlag;
	BOOL* pStopFlag;
	LPARAM Param1;
	LPARAM Param2;
	LPARAM Param3;
	LPARAM Param4;
}THREADPARMS;

CMFC_progView *pData;
CDrawView *pDraw;
CTextView *pText;

UINT TestFunc(LPVOID pParam)
{
    THREADPARMS *pThreadParms = (THREADPARMS*) pParam;
    BOOL *pContFlag = pThreadParms->pContFlag;
    BOOL *pStopFlag = pThreadParms->pStopFlag;
    CChildFrame *pFrame = (CChildFrame*) pThreadParms->Param1;
    pDraw = (CDrawView*) pThreadParms->Param2;
    pData = (CMFC_progView*) pThreadParms->Param3;
    pText = (CTextView*) pThreadParms->Param4;

    delete pThreadParms;

    while (!*pContFlag)
		;

    while (*pContFlag)
    {
       while (*pStopFlag)
   	        ;

	   //test
       AfxMessageBox("program run",MB_OK,0);

       CString str;
       str.Format("MFC test program run \r\n");
	   CEdit& ED = (CEdit&)(pText->GetEditCtrl());
	   ED.SetSel(0,-1);
	   ED.Clear();
       ED.ReplaceSel(str);

       double x, y, x0, y0;
	   
	   x0 = 0;
	   x  = 3;
	   y0 = 10;
	   y  = 10;
       pDraw->draw_line(&x0, &y0, &x, &y);

       for (x = 0; x < 3; x = x+0.01)
       {
          y = sin(2*3.14159*x);
		  y = 10*(1-y);  // Wϊ
		  if (x!=0)
		    pDraw->draw_line(&x0, &y0, &x, &y);
		  x0 = x;
		  y0 = y;
	   }

	   AfxMessageBox("program stop",MB_OK,0);
       *pContFlag = FALSE;
    }
    ::SetEvent(pFrame->m_hEventThreadKilled);
    pFrame->m_pThread = NULL;

    return 0;
}